with Interfaces; use Interfaces;

package body CosNotifyFilter_Filter_Hash is

   P : constant array (0 .. 2) of Natural :=
     (2, 4, 8);

   T1 : constant array (0 .. 2) of Unsigned_8 :=
     (5, 26, 3);

   T2 : constant array (0 .. 2) of Unsigned_8 :=
     (15, 25, 4);

   G : constant array (0 .. 36) of Unsigned_8 :=
     (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 6, 0, 0, 4, 14, 3, 9, 9, 0, 0, 1,
      0, 8, 7, 0, 3, 8, 0, 12, 11, 1, 11, 0, 5, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 37;
         F2 := (F2 + Natural (T2 (K)) * J) mod 37;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 18;
   end Hash;

end CosNotifyFilter_Filter_Hash;
